/*
 *  OtBbNECh̏
 *
 *  $Id:$
 */
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"

int GdevThread_ID ;
int GdevRefreshThread_ID ;
int GdevRefRate ;
#define DEFAULT_GDEVREFRATE   60

#define GRAPHIC_NAME          "POLY TEST"

int WINAPI gdev_thread(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) ;
int WINAPI gdev_refresh_thread(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) ;

int init_window()
{
  
 GdevRefRate=DEFAULT_GDEVREFRATE ;
 GdevSyncReady=0 ;

 gd=NULL ;
 CreateThread(NULL,
 	      0,
 	      (LPTHREAD_START_ROUTINE)gdev_thread,
 	      0,
 	      0,
 	      (PDWORD)&GdevThread_ID) ;
 while(gd==NULL){ char nul[1]={'\0'} ; printf("%s",nul) ; } /** wait for gdev thread ready **/
 CreateThread(NULL,
 	      0,
 	      (LPTHREAD_START_ROUTINE)gdev_refresh_thread,
 	      0,
 	      0,
 	      (PDWORD)&GdevRefreshThread_ID) ;

 return(0) ;
}

int WINAPI gdev_thread (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
 MSG lpMsg;

 gd=OpenGdev(SCREEN_WIDTH, SCREEN_HEIGHT,GRAPHIC_NAME) ;
 if( gd==NULL ){
   fprintf(stderr,"OtBbNfoCX̃I[vɎs܂\n") ;
   exit(-1) ;
 }
 FlushBuffer(gd) ;

 while (GetMessage(&lpMsg, NULL, 0, 0)) {
   TranslateMessage(&lpMsg);
   DispatchMessage(&lpMsg);
 }
 return(0) ;
}

int WINAPI gdev_refresh_thread (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  while(-1){
    if( GdevSyncReady!=0 ){
      RedrawWindow( gd->win, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW ) ;
      GdevSyncReady=0 ;
    }
    Sleep(1000/GdevRefRate) ;
  }
  return(0) ;
}
